[![Sourcecode on GitHub](https://img.shields.io/badge/Paebbels-pyVersioning-323131.svg?logo=github&longCache=true)](https://github.com/Paebbels/pyVersioning)
[![Sourcecode License](https://img.shields.io/pypi/l/pyVersioning?longCache=true&style=flat-square&logo=Apache&label=code)](LICENSE.md)
[![Documentation](https://img.shields.io/website?longCache=true&style=flat-square&label=Paebbels.github.io%2FpyVersioning&logo=GitHub&logoColor=fff&up_color=blueviolet&up_message=Read%20now%20%E2%9E%9A&url=https%3A%2F%2FPaebbels.github.io%2FpyVersioning%2Findex.html)](https://Paebbels.github.io/pyVersioning/)
[![Documentation License](https://img.shields.io/badge/doc-CC--BY%204.0-green?longCache=true&style=flat-square&logo=CreativeCommons&logoColor=fff)](LICENSE.md)  
[![PyPI](https://img.shields.io/pypi/v/pyVersioning?longCache=true&style=flat-square&logo=PyPI&logoColor=FBE072)](https://pypi.org/project/pyVersioning/)
![PyPI - Status](https://img.shields.io/pypi/status/pyVersioning?longCache=true&style=flat-square&logo=PyPI&logoColor=FBE072)
![PyPI - Python Version](https://img.shields.io/pypi/pyversions/pyVersioning?longCache=true&style=flat-square&logo=PyPI&logoColor=FBE072)  
[![GitHub Workflow - Build and Test Status](https://img.shields.io/github/actions/workflow/status/Paebbels/pyVersioning/Pipeline.yml?branch=main&longCache=true&style=flat-square&label=build%20and%20test&logo=GitHub%20Actions&logoColor=FFFFFF)](https://GitHub.com/Paebbels/pyVersioning/actions/workflows/Pipeline.yml)
[![Libraries.io status for latest release](https://img.shields.io/librariesio/release/pypi/pyVersioning?longCache=true&style=flat-square&logo=Libraries.io&logoColor=fff)](https://libraries.io/github/Paebbels/pyVersioning)
[![Codacy - Quality](https://img.shields.io/codacy/grade/fda25870e76849f48bbf7415fb6e9ccf?longCache=true&style=flat-square&logo=Codacy)](https://www.codacy.com/gh/Paebbels/pyVersioning)
[![Codacy - Coverage](https://img.shields.io/codacy/coverage/fda25870e76849f48bbf7415fb6e9ccf?longCache=true&style=flat-square&logo=Codacy)](https://www.codacy.com/gh/Paebbels/pyVersioning)
[![Codecov - Branch Coverage](https://img.shields.io/codecov/c/github/Paebbels/pyVersioning?longCache=true&style=flat-square&logo=Codecov)](https://codecov.io/gh/Paebbels/pyVersioning)


<!--
[![GitHub release date](https://img.shields.io/github/release-date/Paebbels/pyVersioning?logo=GitHub&)](https://github.com/Paebbels/pyVersioning/releases)  
[![Dependent repos (via libraries.io)](https://img.shields.io/librariesio/dependent-repos/pypi/pyVersioning)](https://github.com/Paebbels/pyVersioning/network/dependents)  
-->

# pyVersioning

The Python package `pyVersioning` offers a template tool to write version information for any programming language as a
source file that can be included into the normal application build flow.

The main idea is to provide a unified tool to collect all necessary version information from a configuration file, user
defined parameters, version control systems (e.g. Git) or environment variables. Especially the latter ones can be
tricky in CI environments, as every CI service uses different environment variables.


## Use Cases

* Integrate version information from e.g. Git, GitHub, GitLab, ... into current software builds.


## Supported Languages

* Any language


## Tested with...

* ANSI C
* C++
* VHDL


## Examples

* ANSI C Example
* C++ Example
* VHDL Example


## Contributors

* [Patrick Lehmann](https://github.com/Paebbels) (Maintainer)
* [Navid Jalali](https://github.com/navidcity)
* [and more...](https://GitHub.com/Paebbels/pyVersioning/graphs/contributors)


## License

This Python package (source code) is licensed under [Apache License 2.0](LICENSE.md).  
The accompanying documentation is licensed under Creative Commons - Attribution-4.0 (CC-BY 4.0).


-------------------------

SPDX-License-Identifier: Apache-2.0
